﻿'--------------------------------------------------------------------------------------------------------------------------------------------------
'                           WORLDPOPULATION counter for HOMESEER
' 	     			  based on a script by Jon00 (jon00@btinternet.com) 
'				modified by DJF3 - http://www.domoticaworld.com - info@domoticaworld.com
'--------------------------------------------------------------------------------------------------------------------------------------------------
'PARAMETERS:
'	WPdevice     : (Mandatory) HomeSeer device-code for total population (in device-string only)
'	WPdeviceToday: (Optional) HomeSeer device-code for world population growth since last run (in device-string only)
'  Example: ("Main","P70")
'  Example: ("Main","P70|P71")
'-Create 1 or 2 Status-only devices in HomeSeer. 1 for the total World Population and one for the growth since last ran.
'-Run this script once a day,just past midnight (0:02?)
'
' version 0.4 - July 13 2011	Updated code because census website changed.
' version 0.3c - Jan 27 2011	Updated code. If WPdeviceToday string was empty the script would crash.
' version 0.3b - Jun 07 2010
'	DJ: Added 'feature' where the last days population growth is added to todays growth (in brackets)
' version 0.3 - Feb 27 2010
'	DJ: Prepared for posting. Added comma's in population growth string
'	DJ: changed setdevicestring adding 'true' so the last change date/time is updated (WPdeviceToday)
' version 0.2 - Sep 24 2009
'	DJ: Updated script to  put the world population growth in a different device (WPdeviceToday)
' version 0.1 - Apr 26 
'	DJ: removed text 'worldpopulation:' in devicestring
'--------------------------------------------------------------------------------------------------------------------------------------------------


sub Main(parm as object)

	Dim WPdevice as string
	Dim WPdeviceToday as string
	Dim Worldpop as string
	Dim WPtotal as Double
	Dim WPnew as String
	Dim strDebug as String
	Dim varVersion as String
	
	
	' ***** strDebug = 0,1 or 2
	varVersion = "0.4"
	strDebug=0
	varVersion = "DJ_WorldPopulation_" & varVersion
	' ***** Set WPdevice here! *****
	WPdevice = hs.stringitem(parm, 1, "|")
	WPdeviceToday = hs.stringitem(parm, 2, "|")
	If strDebug>0 then hs.writelog(varVersion,"Worldpopulation now46:" & hs.devicestring(WPdevice))
	If strDebug>0 then hs.writelog(varVersion,"Worldpopulation now47:" & Replace(hs.devicestring(WPdevice),",",""))

	' *******************************
	Worldpop=hs.GetURL("http://www.census.gov","/population/international/",false,80)
	'If strDebug>1 then hs.writelog(varVersion,"Worldpop:51" & Worldpop)
	Worldpop=replace (Worldpop,chr(34),"",1,-1,0)
	Worldpop=hs.StringItem(Worldpop,2,"wclocknum")
	Worldpop=hs.StringItem(Worldpop,1,"</span>")
	Worldpop=Replace(Worldpop,">","",1,-1,1)
	If strDebug>1 then hs.writelog(varVersion,"Worldpop56:" & Worldpop)
	WPtotal = Replace(Worldpop,",","",1,-1,1)
	If strDebug>0 then hs.writelog(varVersion,"Worldpopulation58 TODAY:" & Cstr(Cdbl(WPtotal)-Cdbl(Replace(hs.devicestring(WPdevice),",",""))))
	WPnew = Cstr(Cdbl(WPtotal)-Cdbl(Replace(hs.devicestring(WPdevice),",","")))
	If strDebug>0 then hs.writelog(varVersion,"WPnew60:" & WPnew)
	If Len(WPnew) = 7 then WPnew = Left(Cstr(WPnew),1) + "," + Mid(Cstr(WPnew),1,3) + "," + Right(Cstr(WPnew),3)
	If Len(WPnew) = 6 then WPnew = Left(Cstr(WPnew),3) + "," + Right(Cstr(WPnew),3)
	If Len(WPnew) = 5 then WPnew = Left(Cstr(WPnew),2) + "," + Right(Cstr(WPnew),3)
	If Len(WPnew) = 4 then WPnew = Left(Cstr(WPnew),1) + "," + Right(Cstr(WPnew),3)
	If strDebug>0 then hs.writelog(varVersion,"WPnew65:" & Cstr(WPnew))
	'DJ: If 'total' device was given, set the new value, taking the old value and add it between brackets. IF brackets can be found
	If WPdeviceToday <> "" and Instr(hs.devicestring(WPdeviceToday),"(") > 0 then 
		hs.setdevicestring(WPdeviceToday, WPnew + " (" + Mid(hs.devicestring(WPdeviceToday),1,Instr(hs.devicestring(WPdeviceToday),"(")-1) + ")", true)
	Else If WPdeviceToday <> "" and Instr(hs.devicestring(WPdeviceToday),"(")=0 then
		hs.setdevicestring(WPdeviceToday, WPnew + " (" + hs.devicestring(WPdeviceToday) + ")", true)
	End If
	
	If strDebug>0 then hs.writelog(varVersion,"Just set WPdeviceToday")

	If strDebug>0 and WPdeviceToday<>"" then hs.writelog(varVersion,"Worldpopulation growth:" & WPnew)
	If strDebug>0 then hs.WriteLog(varVersion,"WPdevice:" + WPdevice + " Worldpop:" + Cstr(WPtotal))
	hs.setdevicestring (WPdevice, Worldpop,true)
	
end sub